#!/bin/sh

# Copyright (C) 2020 Rich Brereton
# This program comes with ABSOLUTELY NO WARRANTY;
# for details see license.txt. This is free software, 
# and you are welcome to redistribute it under
# certain conditions; see license.txt for details.
# I request you leave the donation link in the script (I like to eat).
# Rich Brereton - Ricmedia - https://www.ricmedia.com/

# Tell the user a little about the script and how it works, prompt to begin the script
echo 
echo \#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#
echo Welcome to ReSaf - The Reset Safari Script
echo \#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#\#
echo 
echo Copyright \(C\) 2020 Rich Brereton
echo This program comes with ABSOLUTELY NO WARRANTY\; \for details see license\.txt\.
echo This is free software, and you are welcome to redistribute it under certain 
echo conditions\; see license\.txt \for details\.
echo 
echo This script has been tested on macOS Sierra with Safari 10, but should work 
echo on Safari v9\.0 onwards\. This is an interactive script, you will need to answer 
echo Yes\/Agree, No or Cancel to several questions\. Answering Yes\/Agree will perform
echo the script function, answering No will skip that section, answering Cancel will
echo cancel the whole script and exit\.
echo 
echo You must answer Yes to all questions \for ReSaf to work! \(bookmarks optional\)
echo 

# Ask the user to confirm that the script should be run
echo Are you ready to begin?
echo 
select bc in Begin Cancel; do
	case $bc in
		Begin )		echo Beginning ReSaf; break;;
		Cancel )	echo Script has been cancelled. Goodbye; exit;;
	esac
done


# Ask the user to accept the T and Cs of this script
echo 
echo Do you accept the GPL license Terms and Conditions?
echo You can read them \in the license.txt document.
echo 
select tc in Yes Cancel; do
	case $tc in
		Yes ) 		echo You accepted the GPL License Terms and Conditions. Continuing script...; break;;
		Cancel ) 	echo You rejected the GPL License Terms and Conditions. Exiting the script. Goodbye.; exit;;
	esac
done

# Ask the user if they want to backup their bookmarks
echo 
echo Do you want to backup your bookmarks? \(Optional\)
echo 
backup=true
select bub in Yes No Cancel; do
	case $bub in
			Yes )	echo Backing up bookmarks to desktop...;
					cp ~/Library/Safari/Bookmarks.plist ~/Desktop/Bookmarks.plist;
					backup=true;
					echo Done.;
					echo Successfuly backed up bookmarks to desktop.;
					break;;
		No )		backup=false;
					break;;
		Cancel ) 	exit;;
	esac
done

# Ask the user if they want to delete contents of Cookies, Cache and Safari folders
echo 
echo We need to clear the contents of Cookies, Cache and Safari folders.
echo \Do you agree?
echo 
select ccs in Agree Cancel; do
	case $ccs in
		Agree ) 	# Clear all caches, cookies and safari folder
					echo Forcing Safari to quit...;
					killall Safari;
					echo Done.;
					echo 
					echo Clearing Cookies folder contents...;
					rm -Rf ~/Library/Cookies/*;
					echo Done.;
					echo 
					echo Clearing Cache folder contents...;
					rm -Rf ~/Library/Cache/*;
					echo Done.;
					echo 
					echo Clearing Safari folder contents...;
					rm -Rf ~/Library/Safari/*;
					echo Done.;
					echo 
			
			# Some files can be stubborn so we have to explicitly remove them
			echo Removing Safari settings files...;
			rm -Rf ~/Library/Caches/Apple\ -\ Safari\ -\ Safari\ Extensions\ Gallery;
			rm -Rf ~/Library/Caches/Metadata/Safari;
			rm -Rf ~/Library/Caches/com.apple.Safari;
			rm -Rf ~/Library/Caches/com.apple.WebKit.PluginProcess;
			rm -Rf ~/Library/Cookies/Cookies.binarycookies;
			rm -Rf ~/Library/Preferences/Apple\ -\ Safari\ -\ Safari\ Extensions\ Gallery;
			rm -Rf ~/Library/Preferences/com.apple.Safari.LSSharedFileList.plist;
			rm -Rf ~/Library/Preferences/com.apple.Safari.RSS.plist;
			rm -Rf ~/Library/Preferences/com.apple.Safari.plist;
			rm -Rf ~/Library/Preferences/com.apple.WebFoundation.plist;
			rm -Rf ~/Library/Preferences/com.apple.WebKit.PluginHost.plist;
			rm -Rf ~/Library/Preferences/com.apple.WebKit.PluginProcess.plist;
			rm -Rf ~/Library/PubSub/Database;
			rm -Rf ~/Library/Saved\ Application\ State/com.apple.Safari.savedState;
			echo Done.;
			break;;
		# Cancel the script
		Cancel ) echo Exiting the script. Goodbye.; 
			exit;;
	esac
done

# Ask the user if they want to restore their bookmarks
if [ $backup = true ]; then
	echo 
	echo Would you like to restore your bookmarks from backup?
	echo 
	select rb in Yes No Cancel; do
		case $rb in
			Yes )	echo Copying bookmarks backup to Safari folder...;
					rm -Rf ~/Library/Safari/Bookmarks.plist;
					cp ~/Desktop/Bookmarks.plist ~/Library/Safari/Bookmarks.plist;
					echo Done.;
					break;;
			No ) 	echo Skipping restore bookmarks.;
					break;;
			Cancel )echo Exiting the script. Goodbye.; 
					exit;;
		esac
	done

	echo 
	echo Would you like to delete the bookmarks backup from desktop?
	echo
	select rmb in Yes No; do
		case $rmb in
			Yes ) 	echo Deleting bookmarks backup...;
					rm -R ~/Desktop/Bookmarks.plist;
					echo Done.
					break;;
			No )	break;;
		esac
	done
fi

# Tell the user this is the end of the script
echo 
echo ReSaf script has finished resetting Safari\.
echo Find more of Richie\'s scripts at https\:\/\/shop\.ricmedia\.com\/
echo If you got this script for free, please donate to Richie 
echo so he can eat\: https\:\/\/shop\.ricmedia\.com\/donate
echo You may close this window\. Enjoy\!
echo 		

